module MyPCalc1 where

import Parsec
import ParsecExpr

expr :: Parser Integer
expr  = buildExpressionParser table factor
	<?> "expression"

table :: OperatorTable Char () Integer
table  = [
	  [binary "*" (*) AssocLeft, binary "/" div AssocLeft],
	  [binary "+" (+) AssocLeft, binary "-" (-) AssocLeft]
	 ]
    where binary s f assoc
	      = Infix( do{ string s; return f} ) assoc

factor = do { char '('
	    ; x <- expr
	    ; char ')'
	    ; return x
   	    }
	 <|> number
         <?> "simple expression" 

number :: Parser Integer
number  = do {
	      ds <- many1 digit
	     ; return (read ds)
	     }
	  <?> "number"

{-
 parseTest expr "2+5*2"   -- '*' hat hoehere Prioritaet
 parseTest expr "(4+2)*3"  
 parseTest expr "48/2/2"   -- '/' ist links Assoziativ
 parseTest expr "8/(4/2)"  
-} 














